# correct min and max in case max is less than min
execute if score #max quartus < #min quartus run function quartus:switch_min_max

# cap min and max at block grid y values
execute if score #min quartus matches ..0 run scoreboard players set #min quartus 1
execute if score #max quartus matches 256.. run scoreboard players set #max quartus 255

# calculate middle position between max and min
scoreboard players operation #dist quartus = #max quartus
scoreboard players operation #dist quartus -= #min quartus
scoreboard players operation #mid quartus = #dist quartus
scoreboard players operation #mid quartus /= #2 quartus
scoreboard players operation #mid quartus += #min quartus

# reset found before searching
scoreboard players set #found quartus 0

# move marker to the mid height
execute store result entity @s Pos[1] double 1 run scoreboard players get #mid quartus

# binary search through the blocks between min and max to find a cave, starting at mid
scoreboard players operation #i quartus = #dist quartus
scoreboard players operation #i quartus /= #2 quartus
execute at @s if block ~ ~ ~ #quartus:cave_content_overworld run scoreboard players set #found quartus 1
execute unless score #found quartus matches 1 run function quartus:overworld/cave_search

# if nothing was found near mid, check min and max as last resort
execute if score #found quartus matches -1 run function quartus:overworld/cave_search_min_max